/*-----------------------------------------------------------------------------
align_strucs.h

Shyam Prabhakar Aug 08 2003

Definitions of new data types (structs) for multiple alignments.
-----------------------------------------------------------------------------*/

#ifndef ALIGN_STRUCS
#define ALIGN_STRUCS

#include "tree_strucs.h"
#include "annot_strucs.h"
#include "coord_map_strucs.h"
#include "general_strucs.h"


typedef struct
{

  int nrow;               /* no. of aligned sequences */
  int ncol;               /* length of alignment      */
  char **seq_names;       /* array of sequence identifiers */
  char **matrix;          /* the alignment */

  COORD_MAP *coord_maps;  /* array of length nrow, each element of which
			     contains a coordinate map for the corresp. seq */

  PHYLO_TREE *tree;       /* phylogenetic tree */

  int *col_AGCT_distro;   /* distribution of no. of nucs. in a column */
  int *col_num_AGCT;      /* no. of nucleotides in each alignment column */
  int *row_num_AGCT;      /* no. of nucleotides in each alignment row (seq) */
  int *seq_lens;          /* array of sequence lengths (including "N"s) */

  GFF_ANNOT *annots;      /* array of length nrow, each element of which
			     contains annotations for the corresp. sequence */
  GFF_ANNOT super_annot;  /* union of all the exons in all
			     the species annotations */

  SEG_LIST *row_N_segs;   /* array of length nrow, each element of which
			     contains a list of segments of "N"s in the
			     corresponding alignment row */

} ALIGNMENT;  /* phylogenetic tree */

#endif
