/*-----------------------------------------------------------------------------
annot_strucs.h

Shyam Prabhakar Sep 29 2003

Definitions of new data types (structs) for storing GFF-format annotations.
-----------------------------------------------------------------------------*/

#ifndef ANNOT_STRUCS
#define ANNOT_STRUCS

#define GFF_STR_SIZ 40
#define GFF_ATT_SIZ 60

/* NOTE: all coordinates are zero-based! */
/* NOTE: the GFF format allows strings of any size, but what the hell */
typedef struct
{

  char seqname[GFF_STR_SIZ+1];
  char source[GFF_STR_SIZ+1];
  char feature[GFF_STR_SIZ+1];

  int start;  /* sequence coords. */
  int end;

  int algn_start;  /* alignment coords. */
  int algn_end;

  float score;

  char strand;
  char frame;

  char attrib[GFF_ATT_SIZ+1];

} GFF_FEAT;  /* stores info. about a single feature */

typedef struct
{

  GFF_FEAT *feats;  /* array of features */
  int num_feat;     /* array length      */

} GFF_ANNOT;  /* annotation for a single sequence */

#endif
