/*-----------------------------------------------------------------------------
read_file.c

Shyam Prabhakar Aug 08 2003
-----------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>


char *chop_trail_spaces(char *str)
{

  int len;
  char *last;

  last = str + strlen(str) - 1;

  while ( str <= last && isspace(*last) )
    last--;

  *++last = '\0';

}


/*-----------------------------------------------------------------------------
*str_ptr points to the start of a string.

Return the first word in the string, and advance *str_ptr to the first character after the word (or to the end of the string, if no word is found).

A word is defined as any contiguous alphanumeric substring.
If wcase == 'u', the word is converted to uppercase.
If wcase == 'l', the word is converted to lowercase.
Otherwise, the word is read as is.

Return 0 if no word is found.
-----------------------------------------------------------------------------*/
char *chew_first_word(char **str_ptr, char wcase)
{

  int i, word_len = 0;
  char *s = *str_ptr;
  char *word = 0;

  while ( *s && !isalnum(*s) )  s++;

  if ( *s )
    {

      while ( isalnum(*s) )  s++, word_len++;

      word = (char *) malloc( (word_len + 1)*sizeof(char) );

      strncpy(word, s - word_len, word_len);
      word[word_len] = '\0';

      if (wcase == 'u')
	for (i = 0; i < word_len; i++)
	  word[i] = toupper(word[i]);
      else if (wcase == 'l')
	for (i = 0; i < word_len; i++)
	  word[i] = tolower(word[i]);

    }

  *str_ptr = s;
  return word;

}


/*-----------------------------------------------------------------------------
Return the first word in the string *str.

A word is defined as any contiguous alphanumeric substring.
If wcase == 'u', the word is converted to uppercase.
If wcase == 'l', the word is converted to lowercase.
Otherwise, the word is read as is.

Return 0 if no word is found.
-----------------------------------------------------------------------------*/
char *read_first_word(char *str, char wcase)
{

  int i, word_len = 0;
  char *word = 0;

  while ( *str && !isalnum(*str) )  str++;

  if ( *str )
    {

      while ( isalnum(*str) )  str++, word_len++;

      word = (char *) malloc( (word_len + 1)*sizeof(char) );

      strncpy(word, str - word_len, word_len);
      word[word_len] = '\0';

      if (wcase == 'u')
	for (i = 0; i < word_len; i++)
	  word[i] = toupper(word[i]);
      else if (wcase == 'l')
	for (i = 0; i < word_len; i++)
	  word[i] = tolower(word[i]);

    }

  return word;

}


/*-----------------------------------------------------------------------------
Read contents of file into string (ending in '\0') and return pointer to it.
Store length of file (in bytes) in *len_ptr.
As the file is read, new memory is allocated in chunks of size "malloc_siz".

Return value is zero if file not found.
-----------------------------------------------------------------------------*/
char *read_file(char *fname, int *len_ptr, int malloc_siz)
{

  FILE *fp;
  char *contents;
  int c, len = 0;

  if ( !(fp = fopen(fname, "r")) )
    {
      *len_ptr = 0;
      return 0;
    }

  if (malloc_siz < 1)  malloc_siz = 1;

  contents = (char *) malloc(sizeof(char));

  while ( (c = getc(fp)) != EOF )
    {

      if ( !(len % malloc_siz) )
	contents =
	  (char *) realloc(contents, (len + malloc_siz + 1)*sizeof(char));

      contents[len++] = c;

    }

  fclose(fp);

  contents[len] = '\0';
  *len_ptr = len;

  return contents;

}


/*-----------------------------------------------------------------------------
The array field_ptrs had better be at least as long as num_field!!!
-----------------------------------------------------------------------------*/
int get_str_fields(char *str, char **field_ptrs, int nfield)
{

  int i;
  char c;

  for (i = 0; i < nfield; i++)
    {

      while ( (c = *str) && !isgraph(c) ) str++;

      if ( !c )  return 0;

      *field_ptrs++ = str++;

      while ( (c = *str) && isgraph(c) ) str++;

    }

  return 1;

}
